# -*- coding: UTF-8 -*-
#Coders Nikolasi
from Components.Converter.Converter import Converter
from Components.config import config
from Components.Element import cached, ElementError
from enigma import iServiceInformation, eServiceReference, eServiceCenter, iPlayableServicePtr
from ServiceReference import ServiceReference
from Tools.Directories import fileExists
import os, sys

class MovieInfo(Converter, object):
	MOVIE_SHORT_DESCRIPTION = 0 # meta description when available.. when not .eit short description
	MOVIE_META_DESCRIPTION = 1 # just meta description when available
	MOVIE_REC_SERVICE_NAME = 2 # name of recording service
	MOVIE_REC_FILESIZE = 3 # filesize of recording
	MOVIE_REC_NAME = 4 # name of movie
	MOVIE_FULL_DESCRIPTION = 5
	MOVIE_COUNTRY = 6
	MOVIE_GENRE = 7
	MOVIE_DESCRIPTION = 8
	MOVIE_ACTORS = 9	
	MOVIE_RATINGALL = 10
	MOVIE_RATINGCOUT = 11
	MOVIE_DIRECTOR = 12
	MOVIE_YEAR = 13
	
	def __init__(self, type):
		if type == "ShortDescription":
			self.type = self.MOVIE_SHORT_DESCRIPTION
		elif type == "FullDescription":
			self.type = self.MOVIE_FULL_DESCRIPTION
		elif type == "Description":
			self.type = self.MOVIE_DESCRIPTION
		elif type == "Director":
			self.type = self.MOVIE_DIRECTOR
		elif type == "Year":
			self.type = self.MOVIE_YEAR				
		elif type == "Genre":
			self.type = self.MOVIE_GENRE
		elif type == "Actors":
			self.type = self.MOVIE_ACTORS
		elif type == "Coutry":
			self.type = self.MOVIE_COUNTRY
		elif type == "Ratingall":
			self.type = self.MOVIE_RATINGALL
		elif type == "Ratingcount":
			self.type = self.MOVIE_RATINGCOUT			
		elif type == "MetaDescription":
			self.type = self.MOVIE_META_DESCRIPTION
		elif type == "RecordServiceName":
			self.type = self.MOVIE_REC_SERVICE_NAME
		elif type == "FileSize":
			self.type = self.MOVIE_REC_FILESIZE
		elif type == "MovieName":
			self.type = self.MOVIE_REC_NAME			
		else:
			raise ElementError("'%s' is not <ShortDescription|MetaDescription|RecordServiceName|FileSize> for MovieInfo converter" % type)
		Converter.__init__(self, type)

	@cached
	def getText(self):
                dircontrol = False
                eitcontrol = False
                txtcontrol = False
                ts = False
                Country = ''
                Country2 = ''
                genre = ''
                descript = ''
                ratingall = ''
                actors = ''
                fail = ''
                name = ""
                name2 = ""                
                description = ''
                year = ''
                director = ''
                namefil = ''
                eventName = ''
                filename = ''
                namecoverts = ''
		service = self.source.service
		if service:
                        import os.path
                        if isinstance(service, iPlayableServicePtr):
                                info = service and service.info()
                                ref = False
                                refstr = info.getInfoString(iServiceInformation.sServiceref)
                                path = refstr and eServiceReference(refstr).getPath()
                                if path != "":
                                     ts = True                                        
                                     filename = '%s' % (path)
                                else:
                                     name = info.getName()
                                     name2 = config.movielist.last_videodir.value                                        
                                     filename = '%s%s' % (name2, name)
                        else:
                                filename = service.getPath()
                                ref = True
                                info = self.source.info
                        if ref:        
                                if service and (service.flags & eServiceReference.isDirectory):
                                    number = '%s' % (os.path.dirname(filename))
                                    if number.endswith("VIDEO_TS"):
                                           number = number[:-9]
	                            if number != "":
                                         dircontrol = True   
	                                 p = os.path.split(number)
	                                 if not p[1]:
		                              p = os.path.split(p[0])
                                         namefil = '%s' % (p[1])
                                         name = number + '.eit'
                                else:     
                                      name = filename[:-2] + 'eit'                                         
                        else:     
                              name = filename[:-2] + 'eit'
                        if fileExists(name):
                                from Plugins.Extensions.TMBD import event
                                evt = event.Event()
                                evt.readFromFile(name)
                                fail = '%s' % (evt.getShortDescription() + evt.getExtendedDescription())                                
                                if fail != "":
                                    eitcontrol = True    
                                    import StringIO    
                                    readmetafile = StringIO.StringIO(fail)
                        else:
                                if dircontrol:
                                     name = number + '.txt'
                                else:     
                                     name = filename[:-2] + 'txt'
                                if fileExists(name):
                                        txtcontrol = True
                                        readmetafile = open(name, "r")
                        if eitcontrol or txtcontrol:
			            try:
				         Country2 = readmetafile.readline()[0:-1]
				         if "Страна:" in Country2:
                                                 Country = Country2
                                         else:
                                                 Country = '' 
			            except:
				         Country = ''                                
			            try:
				        genre = readmetafile.readline()[0:-1]
			            except:
                                        genre = '' 
			            try:
				         descript = readmetafile.readline()[0:-1]
			            except:
				         descript = ''                                
			            try:
				        ratingall = readmetafile.readline()[0:-1]
			            except:
                                        ratingall = '' 
			            try:
				        actors = readmetafile.readline()[0:-1]
			            except:
                                        actors = ''
			            try:
				        director = readmetafile.readline()[0:-1]
			            except:
                                        director = ''
			            try:
				        year = readmetafile.readline()[0:-1]
			            except:
                                        year = ''
                                    readmetafile.close()  
			if self.type == self.MOVIE_SHORT_DESCRIPTION:
                                return Country +"\n"+ genre or ""                                                 
			elif self.type == self.MOVIE_FULL_DESCRIPTION:
                                return fail or ""
			elif self.type == self.MOVIE_DIRECTOR:
                                return director or ""
			elif self.type == self.MOVIE_YEAR:
                                return year or ""                        
			elif self.type == self.MOVIE_GENRE:
                                return genre or ""                         
			elif self.type == self.MOVIE_ACTORS:
                                return actors or ""
			elif self.type == self.MOVIE_DESCRIPTION:
                                if descript != "":
                                        description = descript
                                elif descript == "" and fail != "":
                                        description = fail    
                                return description or ""
			elif self.type == self.MOVIE_COUNTRY:
                                return Country or ""
			elif self.type == self.MOVIE_RATINGALL:
                                return ratingall or ""
			elif self.type == self.MOVIE_RATINGCOUT:
                                if 'Рейтинг:' in ratingall:
                                        name = ratingall.split('Рейтинг:')[1].split('.')[0].strip()
                                else:
                                        name = ""
                                return name or ""                        
			elif self.type == self.MOVIE_META_DESCRIPTION:
                                return Country +"\n"+ genre or ""
			elif self.type == self.MOVIE_REC_NAME:
                                eventName=""
                                if dircontrol:
                                    eventName = namefil
                                else:        
	                            if filename != "":
                                            name = os.path.split(filename)[1] or ''
                                            if ref:
                                                if name.endswith('.ts'):
                                                        name = service and info.getName(service) or ''
                                            else:
                                                if ts:
                                                   name = info.getName()                                                        
 	                                    counttochra = int(name.count("."))
	                                    if "_" in name:
                                                 name = name.replace("_", " ")
	                                    if counttochra > 1:
                                                cont = counttochra - 1
                                                name = name.replace(".", " ", cont)	                            
	                                    eventName = name
	                            else:
                                            eventName = ""  
	                        return eventName
			elif self.type == self.MOVIE_REC_SERVICE_NAME:
				name = eventName
				return name 
			elif self.type == self.MOVIE_REC_FILESIZE:
                                if fileExists(filename):
				      filesize = int(os.stat(filename).st_size)
				      if filesize is not None:
                                	   return "%d MB" % (filesize / (1024*1024))
				else:                                	
					   return "0 MB"
		return ""

	text = property(getText)
